' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2010                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************

' -----------------------------------------------------------------
' FVIL Sample Program
' 荞ݐݒ_CAO
'
' 쐬 : N.Moriguchi
'
'  : 2011/02/14 
'
' -----------------------------------------------------------------
Public Class FormIntSetting
    Private Const MAX_DIO_BIT As Integer = 32

    Private m_di_enable() As System.Windows.Forms.Label = New System.Windows.Forms.Label(MAX_DIO_BIT - 1) {}
    Private m_di_edge() As System.Windows.Forms.Label = New System.Windows.Forms.Label(MAX_DIO_BIT - 1) {}
    Private m_waitevent_di_enable() As System.Windows.Forms.Label = New System.Windows.Forms.Label(MAX_DIO_BIT - 1) {}

    Public di_enable As UInteger = 0
    Public di_edge As UInteger = 0
    Public int_enable As UInteger = 0
    Public int_edge As UInteger = 0
    Public wait_event_di_enable As UInteger = 0
    Public wait_event_int_enable As UInteger = 0
    Public di_int_mode As UInteger = 0

    ''' <summary>
    ''' tH[
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' IntSettingtH[̏B
    ''' </remarks>
    Private Sub FormIntSetting_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Rg[̔z
        Dim str As String
        For i As Integer = 0 To (MAX_DIO_BIT - 1)
            str = "_labelDIEnable" + i.ToString("00")
            m_di_enable(i) = Me.GetType.GetField(str, Reflection.BindingFlags.Public Or Reflection.BindingFlags.NonPublic Or Reflection.BindingFlags.Instance Or Reflection.BindingFlags.DeclaredOnly).GetValue(Me)
            str = "_labelDIEdge" + i.ToString("00")
            m_di_edge(i) = Me.GetType.GetField(str, Reflection.BindingFlags.Public Or Reflection.BindingFlags.NonPublic Or Reflection.BindingFlags.Instance Or Reflection.BindingFlags.DeclaredOnly).GetValue(Me)
            str = "_labelWaitEventDIEnable" + i.ToString("00")
            m_waitevent_di_enable(i) = Me.GetType.GetField(str, Reflection.BindingFlags.Public Or Reflection.BindingFlags.NonPublic Or Reflection.BindingFlags.Instance Or Reflection.BindingFlags.DeclaredOnly).GetValue(Me)
        Next

        '{^CLICKCxgǉ
        For Each lb As Label In m_di_enable
            AddHandler lb.Click, AddressOf DIEnable_Button_Click
        Next
        For Each lb As Label In m_di_edge
            AddHandler lb.Click, AddressOf DIEdge_Button_Click
        Next
        For Each lb As Label In m_waitevent_di_enable
            AddHandler lb.Click, AddressOf WaitEventDIEnable_Button_Click
        Next

        '
        For i As Integer = 0 To (MAX_DIO_BIT - 1)
            If (((di_enable >> i) And 1) = 1) Then
                m_di_enable(i).BackColor = Color.FromArgb(255, 128, 255)            '(0xFF, 0x80, 0xFF)
                m_di_enable(i).Text = "ENB"
            Else
                m_di_enable(i).BackColor = Color.Gray                               '(0x80, 0x80, 0x80)
                m_di_enable(i).Text = "DIS"
            End If
            If (((di_edge >> i) And 1) = 1) Then
                m_di_edge(i).BackColor = Color.Aqua                                 '(0x00, 0xFF, 0xFF)
                m_di_edge(i).Text = ""
            Else
                m_di_edge(i).BackColor = Color.Gray                                 '(0x80, 0x80, 0x80)
                m_di_edge(i).Text = ""
            End If
            If (((wait_event_di_enable >> i) And 1) = 1) Then
                m_waitevent_di_enable(i).BackColor = Color.FromArgb(255, 128, 255)  '(0xFF, 0x80, 0xFF)
                m_waitevent_di_enable(i).Text = "ENB"
            Else
                m_waitevent_di_enable(i).BackColor = Color.Gray                     '(0x80, 0x80, 0x80)
                m_waitevent_di_enable(i).Text = "DIS"
            End If
        Next

        If (int_enable = 1) Then
            labelINTEnable.BackColor = Color.FromArgb(255, 128, 255)            '(0xFF, 0x80, 0xFF)
            labelINTEnable.Text = "ENB"
        Else
            labelINTEnable.BackColor = Color.Gray                               '(0x80, 0x80, 0x80)
            labelINTEnable.Text = "DIS"
        End If
        If (int_edge = 1) Then
            labelINTEdge.BackColor = Color.Aqua                                 '(0x00, 0xFF, 0xFF)
            labelINTEdge.Text = ""
        Else
            labelINTEdge.BackColor = Color.Gray                                 '(0x80, 0x80, 0x80)
            labelINTEdge.Text = ""
        End If
        If (int_enable = 1) Then
            labelWaitEventINTEnable.BackColor = Color.FromArgb(255, 128, 255)   '(0xFF, 0x80, 0xFF)
            labelWaitEventINTEnable.Text = "ENB"
        Else
            labelWaitEventINTEnable.BackColor = Color.Gray                      '(0x80, 0x80, 0x80)
            labelWaitEventINTEnable.Text = "DIS"
        End If
        If (di_int_mode = 0) Then
            RadioButtonDIINTMode0.Checked = True
        Else
            RadioButtonDIINTMode1.Checked = True
        End If

    End Sub

    ''' <summary>
    ''' OK{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' OK{^B
    ''' </remarks>
    Private Sub ButtonOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonOK.Click
        Dim one As UInteger = 1
        di_enable = 0
        di_edge = 0
        wait_event_di_enable = 0
        For i As Integer = 0 To (MAX_DIO_BIT - 1)
            If (m_di_enable(i).Text = "ENB") Then
                di_enable = di_enable Or (one << i)
            End If
            If (m_di_edge(i).Text = "") Then
                di_edge = di_edge Or (one << i)
            End If
            If (m_waitevent_di_enable(i).Text = "ENB") Then
                wait_event_di_enable = wait_event_di_enable Or (one << i)
            End If
        Next
        If (labelINTEnable.Text = "ENB") Then
            int_enable = 1
        Else
            int_enable = 0
        End If
        If (labelINTEdge.Text = "") Then
            int_edge = 1
        Else
            int_edge = 0
        End If
        If (labelWaitEventINTEnable.Text = "ENB") Then
            wait_event_int_enable = 0
        Else
            wait_event_int_enable = 0
        End If
        If (RadioButtonDIINTMode0.Checked) Then
            di_int_mode = 0
        Else
            di_int_mode = 1
        End If
        Me.DialogResult = Windows.Forms.DialogResult.OK
        Me.Close()

    End Sub

    ''' <summary>
    ''' Cancel{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' Cancel{^B
    ''' </remarks>
    Private Sub ButtonCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonCancel.Click
        Me.DialogResult = Windows.Forms.DialogResult.Cancel
        Me.Close()

    End Sub

    ''' <summary>
    ''' DI Enable{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' DI Enable{^CLICKCxgB
    ''' </remarks>
    Private Sub DIEnable_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        For Each lb As Label In m_di_enable
            If (lb.Equals(sender)) Then
                If (sender.Text = "DIS") Then
                    sender.BackColor = Color.FromArgb(255, 128, 255)        '(0xFF, 0x80, 0xFF)
                    sender.Text = "ENB"
                Else
                    sender.BackColor = Color.Gray                           '(0x80, 0x80, 0x80)
                    sender.Text = "DIS"
                End If
            End If
        Next

    End Sub

    ''' <summary>
    ''' Output{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' Output{^CLICKCxgB
    ''' </remarks>
    Private Sub DIEdge_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        For Each lb As Label In m_di_edge
            If (lb.Equals(sender)) Then
                If (sender.Text = "") Then
                    sender.BackColor = Color.Aqua                           '(0x00, 0xFF, 0xFF)
                    sender.Text = ""
                Else
                    sender.BackColor = Color.Gray                           '(0x80, 0x80, 0x80)
                    sender.Text = ""
                End If
            End If
        Next

    End Sub

    ''' <summary>
    ''' 荞 ĎΏۃ{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' 荞 ĎΏۃ{^CLICKCxgB
    ''' </remarks>
    Private Sub WaitEventDIEnable_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        For Each lb As Label In m_waitevent_di_enable
            If (lb.Equals(sender)) Then
                If (sender.Text = "DIS") Then
                    sender.BackColor = Color.FromArgb(255, 128, 255)        '(0xFF, 0x80, 0xFF)
                    sender.Text = "ENB"
                Else
                    sender.BackColor = Color.Gray                           '(0x80, 0x80, 0x80)
                    sender.Text = "DIS"
                End If
            End If
        Next

    End Sub

    ''' <summary>
    ''' INT Enable / ɐ INT{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' INT Enable{^CLICKCxgB
    ''' </remarks>
    Private Sub labelINTEnable_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles labelINTEnable.Click
        If (labelINTEnable.Text = "DIS") Then
            labelINTEnable.BackColor = Color.FromArgb(255, 128, 255)            '(0xFF, 0x80, 0xFF)
            labelINTEnable.Text = "ENB"
        Else
            labelINTEnable.BackColor = Color.Gray                               '(0x80, 0x80, 0x80)
            labelINTEnable.Text = "DIS"
        End If

    End Sub

    ''' <summary>
    ''' INT Enable / ɐ ɐ{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ɐ{^CLICKCxgB
    ''' </remarks>
    Private Sub labelINTEdge_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles labelINTEdge.Click
        If (labelINTEdge.Text = "") Then
            labelINTEdge.BackColor = Color.Aqua                                 '(0x00, 0xFF, 0xFF)
            labelINTEdge.Text = ""
        Else
            labelINTEdge.BackColor = Color.Gray                                 '(0x80, 0x80, 0x80)
            labelINTEdge.Text = ""
        End If

    End Sub

    ''' <summary>
    ''' 荞 ĎΏINT{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' 荞 ĎΏINT{^CLICKCxgB
    ''' </remarks>
    Private Sub labelWaitEventINTEnable_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles labelWaitEventINTEnable.Click
        If (labelWaitEventINTEnable.Text = "DIS") Then
            labelWaitEventINTEnable.BackColor = Color.FromArgb(255, 128, 255)   '(0xFF, 0x80, 0xFF)
            labelWaitEventINTEnable.Text = "ENB"
        Else
            labelWaitEventINTEnable.BackColor = Color.Gray                      '(0x80, 0x80, 0x80)
            labelWaitEventINTEnable.Text = "DIS"
        End If

    End Sub

End Class